﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using System.Diagnostics;


namespace _03_LinqDemo
{
    class Program
    {
        
        static void Main(string[] args)
        {

            // PLINQ demo
            List<Customer> customers = new List<Customer>() { 
                new Customer(){originalSequenceId=1, Name="Thomas", itemsPurchased =5},
                new Customer(){originalSequenceId=2,Name="Dick", itemsPurchased=3},
                new Customer(){originalSequenceId=3,Name="Harry", itemsPurchased=7},
                new Customer(){originalSequenceId=4,Name="Marcel", itemsPurchased=9},
                new Customer(){originalSequenceId=5,Name="Charly" ,itemsPurchased=7},
                new Customer(){originalSequenceId=6,Name="Jonathan", itemsPurchased =5},
                new Customer(){originalSequenceId=7,Name="Freek", itemsPurchased=3},
                new Customer(){originalSequenceId=8,Name="Mark", itemsPurchased=7},
                new Customer(){originalSequenceId=9,Name="Edwin", itemsPurchased=9},
                new Customer(){originalSequenceId=10,Name="Raimond" ,itemsPurchased=7}
            };

            Stopwatch sw = new Stopwatch();
            sw.Start();

            var CustomersWithSpecialIDs2 = (from customer in customers.AsParallel()
                                            select new
                                            {
                                                seq = customer.originalSequenceId,
                                                name = customer.Name,
                                                items = customer.itemsPurchased,
                                                custNumber = ExpensiveCalculation(customer.Name),
                                                threadID = System.Threading.Thread.CurrentThread.ManagedThreadId
                                            });

            foreach (var item in CustomersWithSpecialIDs2)
            {
                Console.WriteLine(item);
            }

            sw.Stop();

            Console.WriteLine("Processing took {0} MilliSeconds", sw.ElapsedMilliseconds);

           
        }

        static int ExpensiveCalculation(string input)
        {
            // some fake and rather stupid compute intensive algortihm to get a random number
            // just to drive the point, nothing else!
            int count = 100000000;
            int maxValue =0;
            var rand = new Random();
            while (count > 0)
            {
                
                int newNumber = rand.Next(0, count);
                if(newNumber >= maxValue)
                {
                    maxValue = newNumber;
                }
                count--;
            }

            return maxValue;
        }
    }
}
