﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Data.SqlClient;
using _05_LinqDemo.Properties;

namespace _05_LinqDemo
{
    class Program
    {
        static void Main(string[] args)
        {
            // LINQ to datasets demo
          //  UntypedDatasetAccess();
            TypedDataseAccess();
        }


        private static void UntypedDatasetAccess()
        {
            DataSet ds = new DataSet();
            // good old DataSet coding
            SqlConnection con = new SqlConnection(Settings.Default.pubsConnectionString);
            SqlCommand command = new SqlCommand("Select au_lname, au_fName, city from authors", con);
            SqlDataAdapter da = new SqlDataAdapter(command);
            da.Fill(ds);

            // use of AsEnumearable and Field<T> for strong typed columns
            var OrderedAndUppercaseAuthors = from auth in ds.Tables[0].AsEnumerable()
                                             orderby auth.Field<string>("au_lname")
                                             select auth.Field<string>("au_lname").ToUpper();
            foreach (var author in OrderedAndUppercaseAuthors)
            {
                Console.WriteLine(author);
            }

            // null handling in stead of DBNull
            var authorsThatHaveNullValueAsCity = from auth in ds.Tables[0].AsEnumerable()
                                                 where auth.Field<string>("city") == null
                                                 select auth;
            Console.WriteLine("Authors that have a null value as city:");
            foreach (var author in authorsThatHaveNullValueAsCity)
            {
                Console.WriteLine(author.Field<string>("au_lname"));
            }
        }

        private static void TypedDataseAccess()
        {
            Author ds = new Author();
            SqlConnection con = new SqlConnection(Settings.Default.pubsConnectionString);
            SqlCommand command = new SqlCommand("Select au_lname, au_fName, city from authors", con);
            SqlDataAdapter da = new SqlDataAdapter(command);
            da.Fill(ds);


            var OrderedAndUppercaseAuthors = from auth in ds.authors
                                             orderby auth.au_lname
                                             select auth.au_lname.ToUpper();
            foreach (var author in OrderedAndUppercaseAuthors)
            {
                Console.WriteLine(author);
            }


            var authorsWithNullValueCities = from author in ds.authors
                                             where author.city == null
                                             select author;


        }

    
    }
}
